#version 330

// Input vertex data
layout (location = 0) in vec3 vPosition;	// vertex position (in model space)
layout (location = 1) in vec2 vTexCoord;	// texture coordinate (in model space)

// Output data will be interpolated for each fragment.
out vec2 TexCoordPass;

// Values that stay constant for the whole mesh.
uniform mat4 gMVP;

void main()
{
	// Output position of the vertex, in clip space : gMVP * position
	gl_Position =  gMVP * vec4(vPosition,1);	

	TexCoordPass = vTexCoord;
}